Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members | Related Pages

# SlamLineCrossingsTable Class Reference

`#include <SlamLineCrossingsTable.h>`

Collaboration diagram for SlamLineCrossingsTable:

[legend]
List of all members.

## Public Types
enum | CrossingType { lineCrossing, middleCircle }
enum | CrossingClass { unknownCrossing, virtualCrossing, lCrossing, tCrossing, falseCrossing }
enum | { NUMBER_OF_CROSSINGS = 20, NUMBER_OF_CLASSIFIED_CROSSINGS = 18, NUMBER_OF_VIRTUAL_CROSSINGS = 4, NUMBER_OF_T_CROSSINGS = 6, NUMBER_OF_L_CROSSINGS = 8, NUMBER_OF_FALSE_CROSSINGS = 2 }
## Public Member Functions
| SlamLineCrossingsTable ()
Vector2< double > | getClosestPoint (const Vector2< double > &point, CrossingType type)
Vector2< double > | getClassifiedClosestPoint (const Vector2< double > &point, CrossingClass crossingClass)
## Public Attributes
Vector2< double > | allCrossings [NUMBER_OF_CLASSIFIED_CROSSINGS]
Vector2< double > | virtualCrossings [NUMBER_OF_VIRTUAL_CROSSINGS]
Vector2< double > | tCrossings [NUMBER_OF_T_CROSSINGS]
Vector2< double > | lCrossings [NUMBER_OF_L_CROSSINGS]
Vector2< double > | falseCrossings [NUMBER_OF_FALSE_CROSSINGS]
## Static Public Attributes
int | NO_POINT_DISTANCE = 100000
double | crossingsX [NUMBER_OF_CROSSINGS]
double | crossingsY [NUMBER_OF_CROSSINGS]
## Private Member Functions
void | initAllCrossings ()
void | initVirtualCrossings ()
void | initTCrossings ()
void | initLCrossings ()
void | initFalseCrossings ()

## Member Enumeration Documentation

enum SlamLineCrossingsTable::CrossingType

  | Enumeration values:
  lineCrossing |
  middleCircle |
Definition at line 14 of file SlamLineCrossingsTable.h.

enum SlamLineCrossingsTable::CrossingClass

  | Enumeration values:
  unknownCrossing |
  virtualCrossing |
  lCrossing |
  tCrossing |
  falseCrossing |
Definition at line 19 of file SlamLineCrossingsTable.h.

anonymous enum

  | Enumeration values:
  NUMBER_OF_CROSSINGS |
  NUMBER_OF_CLASSIFIED_CROSSINGS |
  NUMBER_OF_VIRTUAL_CROSSINGS |
  NUMBER_OF_T_CROSSINGS |
  NUMBER_OF_L_CROSSINGS |
  NUMBER_OF_FALSE_CROSSINGS |
Definition at line 34 of file SlamLineCrossingsTable.h.

## Constructor & Destructor Documentation

SlamLineCrossingsTable::SlamLineCrossingsTable | ( |  | ) |

| Definition at line 62 of file SlamLineCrossingsTable.cpp. References initAllCrossings(), initFalseCrossings(), initLCrossings(), initTCrossings(), and initVirtualCrossings().

Here is the call graph for this function:

## Member Function Documentation

Vector2< double > SlamLineCrossingsTable::getClosestPoint | ( | const Vector2< double > & | point,
|  | CrossingType | type
| ) |

| Definition at line 72 of file SlamLineCrossingsTable.cpp. References Vector2< V >::abs(), crossingsX, crossingsY, NO_POINT_DISTANCE, and point.

Here is the call graph for this function:

Vector2< double > SlamLineCrossingsTable::getClassifiedClosestPoint | ( | const Vector2< double > & | point,
|  | CrossingClass | crossingClass
| ) |

| Definition at line 90 of file SlamLineCrossingsTable.cpp. References Vector2< V >::abs(), NO_POINT_DISTANCE, and point. Referenced by SlamSelfLocator::updateByCrossing().

Here is the call graph for this function:

void SlamLineCrossingsTable::initAllCrossings | ( |  | ) | `[private]`

| Definition at line 137 of file SlamLineCrossingsTable.cpp. References Vector2< double >::x, and Vector2< double >::y. Referenced by SlamLineCrossingsTable().

void SlamLineCrossingsTable::initVirtualCrossings | ( |  | ) | `[private]`

| Definition at line 200 of file SlamLineCrossingsTable.cpp. References Vector2< double >::x, and Vector2< double >::y. Referenced by SlamLineCrossingsTable().

void SlamLineCrossingsTable::initTCrossings | ( |  | ) | `[private]`

| Definition at line 221 of file SlamLineCrossingsTable.cpp. References Vector2< double >::x, and Vector2< double >::y. Referenced by SlamLineCrossingsTable().

void SlamLineCrossingsTable::initLCrossings | ( |  | ) | `[private]`

| Definition at line 242 of file SlamLineCrossingsTable.cpp. References Vector2< double >::x, and Vector2< double >::y. Referenced by SlamLineCrossingsTable().

void SlamLineCrossingsTable::initFalseCrossings | ( |  | ) | `[private]`

| Definition at line 271 of file SlamLineCrossingsTable.cpp. References Vector2< double >::x, and Vector2< double >::y. Referenced by SlamLineCrossingsTable().

## Member Data Documentation

int SlamLineCrossingsTable::NO_POINT_DISTANCE = 100000`[static]`

| Definition at line 3 of file SlamLineCrossingsTable.cpp. Referenced by getClassifiedClosestPoint(), and getClosestPoint().

double SlamLineCrossingsTable::crossingsX`[static]`

| Initial value:
     {
        xPosOwnGroundline,
        xPosOwnGroundline,
        xPosOwnGroundline,
        xPosOwnGroundline,

        xPosOwnPenaltyArea,
        xPosOwnPenaltyArea,
        xPosOwnPenaltyArea,
        xPosOwnPenaltyArea,

        xPosHalfWayLine,
        xPosHalfWayLine,
        xPosHalfWayLine,
        xPosHalfWayLine,

        xPosOpponentPenaltyArea,
        xPosOpponentPenaltyArea,
        xPosOpponentPenaltyArea,
        xPosOpponentPenaltyArea,

        xPosOpponentGroundline,
        xPosOpponentGroundline,
        xPosOpponentGroundline,
        xPosOpponentGroundline

      }
Definition at line 5 of file SlamLineCrossingsTable.cpp. Referenced by getClosestPoint().

double SlamLineCrossingsTable::crossingsY`[static]`

| Initial value:
    {
        yPosLeftGroundline,
        yPosLeftPenaltyArea,
        yPosRightPenaltyArea,
        yPosRightGroundline,

        yPosLeftGroundline,
        yPosLeftPenaltyArea,
        yPosRightPenaltyArea,
        yPosRightGroundline,

        yPosLeftGroundline,
        yPosLeftPenaltyArea,
        yPosRightPenaltyArea,
        yPosRightGroundline,

        yPosLeftGroundline,
        yPosLeftPenaltyArea,
        yPosRightPenaltyArea,
        yPosRightGroundline,

        yPosLeftGroundline,
        yPosLeftPenaltyArea,
        yPosRightPenaltyArea,
        yPosRightGroundline

      }
Definition at line 33 of file SlamLineCrossingsTable.cpp. Referenced by getClosestPoint().

Vector2<double> SlamLineCrossingsTable::allCrossings[NUMBER_OF_CLASSIFIED_CROSSINGS]

| Definition at line 46 of file SlamLineCrossingsTable.h.

Vector2<double> SlamLineCrossingsTable::virtualCrossings[NUMBER_OF_VIRTUAL_CROSSINGS]

| Definition at line 47 of file SlamLineCrossingsTable.h.

Vector2<double> SlamLineCrossingsTable::tCrossings[NUMBER_OF_T_CROSSINGS]

| Definition at line 48 of file SlamLineCrossingsTable.h.

Vector2<double> SlamLineCrossingsTable::lCrossings[NUMBER_OF_L_CROSSINGS]

| Definition at line 49 of file SlamLineCrossingsTable.h.

Vector2<double> SlamLineCrossingsTable::falseCrossings[NUMBER_OF_FALSE_CROSSINGS]

| Definition at line 50 of file SlamLineCrossingsTable.h.

The documentation for this class was generated from the following files:

- Modules/SelfLocator/SlamSelfLocator/SlamLineCrossingsTable.h
- Modules/SelfLocator/SlamSelfLocator/SlamLineCrossingsTable.cpp